Codeforces Round #419 (Div. 2)

题目链接:http://codeforces.com/contest/816

A. Karen and Morning
time limit per test
2 seconds
memory limit per test
512 megabytes
input
standard input
output
standard output

Karen is getting ready for a new school day!

It is currently hh:mm, given in a 24-hour format. As you know, Karen loves palindromes, and she believes that it is good luck to wake up when the time is a palindrome.

What is the minimum number of minutes she should sleep, such that, when she wakes up, the time is a palindrome?

Remember that a palindrome is a string that reads the same forwards and backwards. For instance, 05:39 is not a palindrome, because 05:39 backwards is 93:50. On the other hand, 05:50 is a palindrome, because 05:50 backwards is 05:50.

Input

The first and only line of input contains a single string in the format hh:mm (00 ≤  hh  ≤ 2300 ≤  mm  ≤ 59).

Output

Output a single integer on a line by itself, the minimum number of minutes she should sleep, such that, when she wakes up, the time is a palindrome.

Examples
input
05:39
output
11
input
13:31
output
0
input
23:59
output
1
Note

In the first test case, the minimum number of minutes Karen should sleep for is 11. She can wake up at 05:50, when the time is a palindrome.

In the second test case, Karen can wake up immediately, as the current time, 13:31, is already a palindrome.

In the third test case, the minimum number of minutes Karen should sleep for is 1 minute. She can wake up at 00:00, when the time is a palindrome.

解析:求下个时刻的回文串,直接模拟就好了

代码:

#include<bits/stdc++.h>
#define N 2000009
using namespace std;
typedef long long LL;



bool check(int h, int m)
{
    if(h == m && !h) return true;
    char s[109];
    if(h < 10)
    {
        s[0] = '0';
        s[1] = h % 10 + '0';
    }
    else
    {
        s[1] = h % 10 + '0'; h /= 10;
        s[0] = h % 10 + '0';
    }
    if(m < 10)
    {
        s[2] = '0';
        s[3] = m % 10 + '0';
    }
    else
    {
        s[3] = m % 10 + '0'; m /= 10;
        s[2] = m % 10 + '0';
    }
    for(int i = 0, j = 3; i <= j; i++, j--)
    {
        if(s[i] != s[j]) return false;
    }
    return true;
}

int main()
{
    int h, m, ans = 0;
    scanf("%d:%d", &h, &m);
    while(true)
    {
        if(check(h, m)) break;
        m++;
        if(m >= 60) h = (h + 1) % 24;
        m = m % 60;
        ans++;
    }
    printf("%d\n", ans);
    return 0;
}

B. Karen and Coffee
time limit per test
2.5 seconds
memory limit per test
512 megabytes
input
standard input
output
standard output

To stay woke and attentive during classes, Karen needs some coffee!

Karen, a coffee aficionado, wants to know the optimal temperature for brewing the perfect cup of coffee. Indeed, she has spent some time reading several recipe books, including the universally acclaimed "The Art of the Covfefe".

She knows n coffee recipes. The i-th recipe suggests that coffee should be brewed between li and ri degrees, inclusive, to achieve the optimal taste.

Karen thinks that a temperature is admissible if at least k recipes recommend it.

Karen has a rather fickle mind, and so she asks q questions. In each question, given that she only wants to prepare coffee with a temperature between a and b, inclusive, can you tell her how many admissible integer temperatures fall within the range?

Input

The first line of input contains three integers, nk (1 ≤ k ≤ n ≤ 200000), and q (1 ≤ q ≤ 200000), the number of recipes, the minimum number of recipes a certain temperature must be recommended by to be admissible, and the number of questions Karen has, respectively.

The next n lines describe the recipes. Specifically, the i-th line among these contains two integers li and ri (1 ≤ li ≤ ri ≤ 200000), describing that the i-th recipe suggests that the coffee be brewed between li and ri degrees, inclusive.

The next q lines describe the questions. Each of these lines contains a and b, (1 ≤ a ≤ b ≤ 200000), describing that she wants to know the number of admissible integer temperatures between a and b degrees, inclusive.

Output

For each question, output a single integer on a line by itself, the number of admissible integer temperatures between a and b degrees, inclusive.

Examples
input
3 2 4
91 94
92 97
97 99
92 94
93 97
95 96
90 100
output
3
3
0
4
input
2 1 1
1 1
200000 200000
90 100
output
0
Note

In the first test case, Karen knows 3 recipes.

  1. The first one recommends brewing the coffee between 91 and 94 degrees, inclusive.
  2. The second one recommends brewing the coffee between 92 and 97 degrees, inclusive.
  3. The third one recommends brewing the coffee between 97 and 99 degrees, inclusive.

A temperature is admissible if at least 2 recipes recommend it.

She asks 4 questions.

In her first question, she wants to know the number of admissible integer temperatures between 92 and 94 degrees, inclusive. There are 39293 and 94 degrees are all admissible.

In her second question, she wants to know the number of admissible integer temperatures between 93 and 97 degrees, inclusive. There are 39394 and 97 degrees are all admissible.

In her third question, she wants to know the number of admissible integer temperatures between 95 and 96 degrees, inclusive. There are none.

In her final question, she wants to know the number of admissible integer temperatures between 90 and 100 degrees, inclusive. There are 4929394 and 97 degrees are all admissible.

In the second test case, Karen knows 2 recipes.

  1. The first one, "wikiHow to make Cold Brew Coffee", recommends brewing the coffee at exactly 1 degree.
  2. The second one, "What good is coffee that isn't brewed at at least 36.3306 times the temperature of the surface of the sun?", recommends brewing the coffee at exactly 200000 degrees.

A temperature is admissible if at least 1 recipe recommends it.

In her first and only question, she wants to know the number of admissible integer temperatures that are actually reasonable. There are none.

解析:求每个数在所有区间中出现了几次,咱可以用一个数组标记一下,每次加加,最后求前缀和,但这样会超时; 思路2(学长的思路,逃,,,):就是把所有加加去掉,变成每遇到一个区间[l, r],        vis[l]++, vis[r+1]--,然后遍历一遍vis[i] += vis[i-1],再求一下前缀和,最后直接输出sum[r]-sum[l-1]

代码:

#include<bits/stdc++.h>
#define N 200009
using namespace std;
typedef long long LL;

int a[N], sum[N];

int main()
{
    memset(a, 0, sizeof(a));
    sum[0] = 0;
    int n, k, q, l, r;
    scanf("%d%d%d", &n, &k, &q);
    for(int i = 1; i <= n; i++)
    {
        scanf("%d%d", &l, &r);
        a[l]++; a[r+1]--;
    }
    for(int i = 1; i < N; i++)
    {
        a[i] += a[i-1];
    }
    for(int i = 1; i < N; i++)
    {
        if(a[i] >= k) a[i] = 1;
        else a[i] = 0;
    }

    //for(int i = 90; i <= 100; i++) cout << a[i] << endl;
    for(int i = 1; i < N; i++)
    {
        sum[i] = sum[i-1] + a[i];
    }
    while(q--)
    {
        scanf("%d%d", &l, &r);
        printf("%d\n", sum[r] - sum[l-1]);
    }
    return 0;
}

C. Karen and Game
time limit per test
2 seconds
memory limit per test
512 megabytes
input
standard input
output
standard output

On the way to school, Karen became fixated on the puzzle game on her phone!

The game is played as follows. In each level, you have a grid with n rows and m columns. Each cell originally contains the number 0.

One move consists of choosing one row or column, and adding 1 to all of the cells in that row or column.

To win the level, after all the moves, the number in the cell at the i-th row and j-th column should be equal to gi, j.

Karen is stuck on one level, and wants to know a way to beat this level using the minimum number of moves. Please, help her with this task!

Input

The first line of input contains two integers, n and m (1 ≤ n, m ≤ 100), the number of rows and the number of columns in the grid, respectively.

The next n lines each contain m integers. In particular, the j-th integer in the i-th of these rows contains gi, j (0 ≤ gi, j ≤ 500).

Output

If there is an error and it is actually not possible to beat the level, output a single integer -1.

Otherwise, on the first line, output a single integer k, the minimum number of moves necessary to beat the level.

The next k lines should each contain one of the following, describing the moves in the order they must be done:

  • row x, (1 ≤ x ≤ n) describing a move of the form "choose the x-th row".
  • col x, (1 ≤ x ≤ m) describing a move of the form "choose the x-th column".

If there are multiple optimal solutions, output any one of them.

Examples
input
3 5
2 2 2 3 2
0 0 0 1 0
1 1 1 2 1
output
4
row 1
row 1
col 4
row 3
input
3 3
0 0 0
0 1 0
0 0 0
output
-1
input
3 3
1 1 1
1 1 1
1 1 1
output
3
row 1
row 2
row 3
Note

In the first test case, Karen has a grid with 3 rows and 5 columns. She can perform the following 4 moves to beat the level:

In the second test case, Karen has a grid with 3 rows and 3 columns. It is clear that it is impossible to beat the level; performing any move will create three 1s on the grid, but it is required to only have one 1 in the center.

In the third test case, Karen has a grid with 3 rows and 3 columns. She can perform the following 3 moves to beat the level:

Note that this is not the only solution; another solution, among others, is col 1col 2col 3.

解析:直接模拟下,注意m==1||n==1的情况,这题是上午刚补的题,昨天晚上没做对,弱鸡一个

代码:

#include<iostream>
#include<algorithm>
#include<queue>
#include<map>
#include<cstdio>
#include<cstdlib>
#include<cmath>
#include<cstring>
#include<cctype>
#define N 5009
using namespace std;

int mp[N][N], x[5000009], y[5000009];
int x_len, y_len;
int m, n;

void get_x()
{
    for(int i = 1; i <= m; i++)
    {
        int k = 0x3f3f3f3f;
        for(int j = 1; j <= n; j++)
        {
            k = min(k, mp[i][j]);
        }
        for(int j = 1; j <= n; j++) mp[i][j] -= k;
        while(k--)
        {
            x[x_len++] = i;
        }
    }
}


void get_y()
{
    for(int j = 1; j <= n; j++)
    {
        int k = 0x3f3f3f3f;
        for(int i = 1; i <= m; i++)
        {
            k = min(k, mp[i][j]);
        }
        for(int i = 1; i <= m; i++) mp[i][j] -= k;
        while(k--)
        {
            y[y_len++] = j;
        }
    }
}

bool check()
{
    for(int i = 1; i <= m; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            if(mp[i][j]) return false;
        }
    }
    return true;
}

int main()
{

    scanf("%d%d", &m, &n);
    for(int i = 1; i <= m; i++)
    {
        for(int j = 1; j <= n; j++) scanf("%d", &mp[i][j]);
    }
    x_len = y_len = 0;
    if(n <= m)
    {
        get_y(); get_x();
    }
    else
    {
        get_x(); get_y();
    }
    if(!check()) puts("-1");
    else
    {
        printf("%d\n", x_len + y_len);
        for(int i = 0; i < x_len; i++) printf("row %d\n", x[i]);
        for(int i = 0; i < y_len; i++) printf("col %d\n", y[i]);
    }
    return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值